class AutomataCellular {

	int[][] cellsBuffer;

	AutomataCellular() {
		cellsBuffer = new int[level.imageData.width/cellSize][level.imageData.height/cellSize];
	}


	void iteration(int[][] cells) { // When the clock ticks
  	// Save cells to buffer (so we opeate with one array keeping the other intact)
	  for (int x=0; x<level.imageData.width/cellSize; x++) {
	    for (int y=0; y<level.imageData.height/cellSize; y++) {
	      cellsBuffer[x][y] = cells[x][y];
	    }
	  }

	  // Visit each cell:
	  for (int x=0; x<level.imageData.width/cellSize; x++) {
	    for (int y=0; y<level.imageData.height/cellSize; y++) {

	      // And visit all the neighbours of each cell
	      int neighbours = 0; // We'll count the neighbours
	      for (int xx=x-1; xx<=x+1;xx++) {
	        for (int yy=y-1; yy<=y+1;yy++) {  
	          if (((xx>=0)&&(xx<level.imageData.width/cellSize))&&((yy>=0)&&(yy<level.imageData.height/cellSize))) { // Make sure you are not out of bounds
	            if (!((xx==x)&&(yy==y))) { // Make sure to to check against self
	              if (cellsBuffer[xx][yy] == cellStatusBad){
	                neighbours ++; // Check alive neighbours and count them
	              }
	            } // End of if
	          } // End of if
	        } // End of yy loop
	      } //End of xx loop
	      // We've checked the neigbours: apply rules!
	      if (cellsBuffer[x][y] == cellStatusBad) { // The cell is alive: kill it if necessary
	        if (neighbours < 2 || neighbours > 3) {
	          cells[x][y] = cellStatusDead; // Die unless it has 2 or 3 neighbours
	        }
	      } 
	      else  { // The cell is dead: make it live if necessary      
	        if (neighbours == 3 ) {
	          cells[x][y] = cellStatusBad; // Only if it has 3 neighbours
	        }
	      } // End of if
	    } // End of y loop
	  } // End of x loop
	} // End of function
}
