class Hud {

	PFont fontTitle, fontButton, fontParagraph;

	String explanation = "You are inside a human body ravaged by sickness.\nDestroy bad cells before they kill vital cells.";
	String controls = "Controls :\nMove with arrows\nAim with mouse\nShoot with clic\nHold mouse button for autofire";
	String credits = "Concept & Code : Leon Denise\nPixel Anatomy : Simon Denise";
	String references = "Inspired by Rick Levine's Microsurgeon and Conway's Game of Life";

	PVector anchor;

	final float JAUGE_HEIGHT = 8;
	final float JAUGE_MAX_WIDTH = 256;

	Hud() {

	  // Create the font
	  // printArray(PFont.list());
	  fontTitle = createFont("Cachiyuyo", 64, false);
	  fontButton = createFont("Cachiyuyo", 32, false);
	  fontParagraph = createFont("Cachiyuyo", 16, false);

	  anchor = new PVector(24, 24);
	}

	void Update() {

		// Start Menu
		if (pause) {

			background(255);

			if (!gameOver) {

				textAlign(CENTER);
				fill(0);
				textFont(fontParagraph);
				text(explanation, screenX * 0.5, screenY * 0.35);
				text(controls, screenX * 0.5, screenY * 0.6);
				fill(100);
				text(credits, screenX * 0.5, screenY * 0.85);
				text(references, screenX * 0.5, screenY * 0.95);
				textFont(fontTitle);
				fill(0);
				text("PIXEL SURGEON", screenX * 0.5, screenY * 0.25);
				textFont(fontButton);
				fill(200, 0, 0);
				text("START", screenX * 0.5, screenY * 0.5);

		  		if (mousePressed && TestCollision(mouseX, mouseY, int(screenX * 0.5 - 80), int(screenY * 0.5 - 64), 160, 64)) {
		  			StartGame();
		  			pause = false;
		  		}

			} else {

				textAlign(CENTER);
				textFont(fontTitle);
				fill(0);
				text("Game Over", screenX * 0.5, screenY * 0.5);
				textFont(fontButton);
				fill(200, 0, 0);
				text("RESTART", screenX * 0.5, screenY * 0.6);

		  		if (mousePressed && TestCollision(mouseX, mouseY, int(screenX * 0.5 - 96), int(screenY * 0.6 - 64), 192, 64)) {
		  			StartGame();
		  			pause = false;
		  			gameOver = false;
		  		}
			}

	  	// In Game
	  	} else {

	  		// float[] ratios = GetRatioCells(); 
	  		// for (int c = 0; c < ratios.length; c++){
	  		// 	fill(GetColorByType(cellStatusHeart));
	  		// 	rect(anchor.x, anchor.y + c * (JAUGE_HEIGHT + JAUGE_HEIGHT * 0.5), ratios[c] * JAUGE_MAX_WIDTH, JAUGE_HEIGHT);
	  		// }
	  		// Waves
			textAlign(LEFT);
			fill(255);
			textFont(fontParagraph);
			text("left clic : heal\nright clic : lazer", anchor.x, anchor.y + JAUGE_HEIGHT);


	  		// Waves
			textAlign(RIGHT);
			fill(255);
			textFont(fontParagraph);
			text("waves : " + waves + "\nbad cells : " + cellCountBad/(cellSize*cellSize), screenX - anchor.x, anchor.y + JAUGE_HEIGHT);
	  	}
	}
}
