class Player {

	Cell[][] body;
	PVector position;
	float speed = 12;
	int bodySize = 2;
	color cellColor = color(0, 0, 255);

	ArrayList<Bullet> bullets;
	float fireRate = 30;
	float lastFiredTime = 0;
	int bulletRadius = 2;

	Player () {
		position = new PVector(screenX / 2, screenY / 2);
		// body = new Cell[bodySize][bodySize];
		// for (int x = 0; x < bodySize; x++) {
		// 	for (int y = 0; y < bodySize; y++) {
		// 		body[x][y] = new Cell(x, y, color(0, 0, 255));
		// 	}
		// }

		bullets = new ArrayList<Bullet>();
	}

	void Update() {

		// 
		Draw();

		// MOVE
		Move();

		// BULLETS FIRE
  		if (millis() - lastFiredTime > fireRate && mouseButton == LEFT) {
			Shoot();
			lastFiredTime = millis();
		}
	}

	void Draw() {
		// noStroke();
		// fill(255);
		// rect(position.x - cellSize * 2, position.y - cellSize, cellSize * 5, cellSize * 3);
		// rect(position.x - cellSize, position.y - cellSize * 2, cellSize * 3, cellSize * 5);
		fill(#23fe12);
		rect(position.x - cellSize, position.y - cellSize, cellSize * 3, cellSize * 3);
	}

	float scrollOffset = screenX * 0.4;

	void Move() {

		// Moving
		if (keys.get("up") == 1) {
			position.y = max(0, min(position.y - speed, screenY - bodySize * cellSize)); 
		} else if (keys.get("down") == 1) {
			position.y = max(0, min(position.y + speed, screenY - bodySize * cellSize)); 
		}
		if (keys.get("left") == 1) {
			position.x = max(0, min(position.x - speed, screenX - bodySize * cellSize)); 
		} else if (keys.get("right") == 1) {
			position.x = max(0, min(position.x + speed, screenX - bodySize * cellSize)); 
		}

		// Scrolling
		if (position.x < scrollOffset && level.scroll.x < 0) {

			level.scroll.x = min(0, max(level.scroll.x + speed, screenX - level.imageData.width));
			position.x = scrollOffset;

		} else if (position.x > screenX - scrollOffset && level.scroll.x > screenX - level.imageData.width)  {

			level.scroll.x = min(0, max(level.scroll.x - speed, screenX - level.imageData.width));
			position.x = screenX - scrollOffset;

		} 

		// Scrolling
		if (position.y < scrollOffset && level.scroll.y < 0) {

			level.scroll.y = min(0, max(level.scroll.y + speed, screenY - level.imageData.height));
			position.y = scrollOffset;

		} else if (position.y > screenY - scrollOffset && level.scroll.y > screenY - level.imageData.height)  {

			level.scroll.y = min(0, max(level.scroll.y - speed, screenY - level.imageData.height));
			position.y = screenY - scrollOffset;

		} 
		
	}

	void Shoot() {
		int x = int(position.x / cellSize);
		int y = int(position.y / cellSize);
		boolean recycling = false;
		for (int b = 0; b < bullets.size(); b++) {
			Bullet bullet = bullets.get(b);
			if (bullet.IsAlive() == false) {
				bullet.Start(position.x, position.y, mouseX - position.x, mouseY - position.y, level.cells[x][y]);
				recycling = true;
				break;
			}
		}
		if (!recycling) {
			bullets.add(new Bullet(position.x, position.y, mouseX - position.x, mouseY - position.y, level.cells[x][y]));
		}
	}

	int BulletAt(int x, int y) {
		for (int b = 0; b < bullets.size(); b++) {
			Bullet bullet = bullets.get(b);
			float bX = bullet.position.x - level.scroll.x;
			float bY = bullet.position.y - level.scroll.y;
			if (x > int(bX - bulletRadius) &&
				x < int(bX + bulletRadius) && 
				y > int(bY - bulletRadius) && 
				y < int(bY + bulletRadius)) {
				return b;
			}
		}
		return -1;
	}

	void KillBullet(int index) {
		bullets.remove(index);
	}
}
