

final int cellStatusDead = 0;
final int cellStatusBad = 1;
final int cellStatusHeart = 2;
final int cellStatusVeinRed = 3;
final int cellStatusVeinBlue = 4;
final int cellStatusLung = 5;
final int cellStatusBone = 6;
final int cellStatusSkinLight = 7;
final int cellStatusSkinMedium = 8;
final int cellStatusSkinDark = 9;
final int cellStatusTendon = 10;
final int cellStatusBrain = 11;
final int cellStatusEye = 12;
final int cellStatusSkinShadow = 13;
final int cellStatusOrganYellow = 14;
final int cellStatusInstetinLigh = 15;
final int cellStatusInstetinMedium = 16;
final int cellStatusSkinLeg = 17;
final int cellStatusOrganBrownLight = 18;
final int cellStatusOrganBrownMedium = 19;
final int cellStatusOrganBrownDark = 20;
final int cellStatusOrganBrownVeryLight = 21;
final int cellStatusOrganBrownFade = 22;
final int cellStatusOrganBrownAgain = 23;
final int cellStatusOrganBrownOther = 24;

final int cellStatusBullet = 1000;
final int cellStatusLazer = 9000;

int GetTypeByColor(color cellColor) {
  int type = 0;
  switch (cellColor){
    case 0:
    case #000000:
      type = cellStatusDead;
      break;
    case #cccccc:
      type = cellStatusBad;
    case #ff7c7b:
      type = cellStatusHeart;
      break ;
    case #ff057b:
      type = cellStatusVeinRed;
      break;
    case #7777ff:
      type = cellStatusVeinBlue;
      break;
    case #ffc57b:
      type = cellStatusLung;
      break;
    case #fff4bd:
      type = cellStatusBone;
      break;
    case #48d24f:
      type = cellStatusBullet;
      break;
    case #f6cbac:
      type = cellStatusSkinLight;
      break;
    case #e2b698:
      type = cellStatusSkinMedium;
      break;
    case #d09170:
      type = cellStatusSkinDark;
      break;
    case #f8d0cb:
      type = cellStatusTendon;
      break;
    case #ffc07b:
    case #ffbd7b:
    case #feb97b:
    case #febf7b:
      type = cellStatusBrain;
      break;
    case #ffffff:
      type = cellStatusEye;
      break;
    case #ad5632:
      type = cellStatusSkinShadow;
      break;
    case #efd362:
      type = cellStatusOrganYellow;
      break;
    case #eccb86:
      type = cellStatusInstetinLigh;
      break;
    case #d8b572:
      type = cellStatusInstetinMedium;
      break;
    case #ecd4bb:
      type = cellStatusSkinLeg;
      break;
    case #c7653d:
      type = cellStatusOrganBrownLight;
      break;
    case #bb5438:
      type = cellStatusOrganBrownMedium;
      break;
    case #a3522e:
      type = cellStatusOrganBrownDark;
      break;
    case #ce9773:
      type = cellStatusOrganBrownVeryLight;
      break;
    case #a87b59:
      type = cellStatusOrganBrownFade;
      break;
    case #e7d2c1:
      type = cellStatusOrganBrownAgain;
      break;
    case #b06a49:
      type = cellStatusOrganBrownOther;
      break;
    case #12bf03:
      type = cellStatusLazer;
      break;
  }
  return type;
}

color GetColorByType(int cellType) {
  color color_ = #000000;
  switch (cellType){
    case cellStatusDead:
      color_ = #000000;
      break;
    case cellStatusBad:
      color_ = #cccccc;
      break;
    case cellStatusHeart:
      color_ = #ff7c7b;
      break;
    case cellStatusVeinRed:
      color_ = #ff057b;
      break;
    case cellStatusVeinBlue:
      color_ = #7777ff;
      break;
    case cellStatusLung:
      color_ = #ffc57b;
      break;
    case cellStatusBone:
      color_ = #fff4bd;
      break;
    case cellStatusBullet:
      color_ = #48d24f;
      break;
    case cellStatusSkinLight:
      color_ = #f6cbac;
      break;
    case cellStatusSkinMedium:
      color_ = #e2b698;
      break;
    case cellStatusSkinDark:
      color_ = #d09170;
      break;
    case cellStatusTendon:
      color_ = #f8d0cb;
      break;
    case cellStatusBrain:
      color_ = #ffc07b;
      break;
    case cellStatusEye:
      color_ = #ffffff;
      break;
    case cellStatusSkinShadow:
      color_ = #ad5632;
      break;
    case cellStatusOrganYellow:
      color_ = #efd362;
      break;
    case cellStatusInstetinLigh:
      color_ = #eccb86;
      break;
    case cellStatusInstetinMedium:
      color_ = #d8b572;
      break;
    case cellStatusSkinLeg:
      color_ = #ecd4bb;
      break;
    case cellStatusOrganBrownLight:
      color_ = #c7653d;
      break;
    case cellStatusOrganBrownMedium:
      color_ = #bb5438;
      break;
    case cellStatusOrganBrownDark:
      color_ = #a3522e;
      break;
    case cellStatusOrganBrownVeryLight:
      color_ = #ce9773;
      break;
    case cellStatusOrganBrownFade:
      color_ = #a87b59;
      break;
    case cellStatusOrganBrownAgain:
      color_ = #e7d2c1;
      break;
    case cellStatusOrganBrownOther:
      color_ = #b06a49;
      break;
    case cellStatusLazer:
      color_ = #12bf03;
      break;
  }
  return color_;
}

boolean TestCollision(int x, int y, int xx, int yy, int ww, int hh) {
  return (x > xx && x < xx + ww && y > yy && y < yy + hh);
}

int cellTotalVital = 1;
int cellCountVital = 1;
int cellCountBad = 1;
int cellCountHeart = 1;
int cellCountLung = 1;
int cellCountBrain = 1;
int cellCountSkin = 1;
int cellTotalHeart = 1;
int cellTotalBrain = 1;
int cellTotalSkin = 1;
int cellTotalLung = 1;

void CountCell(int cellStatus) {
  switch (cellStatus){
    case cellStatusHeart:
      cellCountHeart++;
      break;
    case cellStatusLung:
      cellCountLung++;
      break;
    case cellStatusVeinRed:
      cellCountVital++;
      break;
    case cellStatusBrain:
      cellCountBrain++;
      break;
    case cellStatusSkinLeg:
    case cellStatusSkinShadow:
    case cellStatusSkinDark:
    case cellStatusSkinMedium:
    case cellStatusSkinLight:
      cellCountSkin++;
      break;
    case cellStatusBad:
      cellCountBad++;
      break;
  }
}

void ResetCount() {
  cellCountBad = 1;
  cellCountVital = 1;
  cellTotalBrain = 1;
  cellTotalSkin = 1;
  cellTotalLung = 1;
  cellTotalHeart = 1;
  // cellCounts = new IntDict();
  // cellTotals = new IntDict();
}

void CheckoutCount() {
  cellTotalVital = cellCountVital/(cellSize*cellSize);
  cellTotalBrain = cellCountBrain/(cellSize*cellSize);
  cellTotalSkin = cellCountSkin/(cellSize*cellSize);
  cellTotalLung = cellCountLung/(cellSize*cellSize);
  cellTotalHeart = cellCountHeart/(cellSize*cellSize);
  // cellTotals = new IntDict();
  // String[] countKeys = cellCounts.keyArray();
  // int[] countValues = cellCounts.valueArray();
  // for (int c = 0; c < countKeys.length; c++) {
  //   cellTotals.set(countKeys[c], countValues[c]);
  // }
}

float[] GetRatioCells() {
  float[] cells = new float[5];
  cells[0] = cellCountVital/(cellSize*cellSize) / float(cellTotalVital);
  cells[1] = cellCountBrain/(cellSize*cellSize) / float(cellTotalBrain);
  cells[2] = cellCountSkin/(cellSize*cellSize) / float(cellTotalSkin);
  cells[3] = cellCountLung/(cellSize*cellSize) / float(cellTotalLung);
  cells[4] = cellCountHeart/(cellSize*cellSize) / float(cellTotalHeart);
  return cells;
}

float GetVitalCellRatio() {
  return cellCountVital/(cellSize*cellSize) / float(cellTotalVital);
  // int countVital = 0;
  // int countTotal = 0;
  // String[] countKeys = cellCounts.keyArray();
  // String[] totalKeys = cellTotals.keyArray();
  // for (int c = 0; c < countKeys.length; c++) 
  //   if (countKeys[c] != "status_0" || countKeys[c] != "status_1") 
  //     countVital++;
  // for (int c = 0; c < totalKeys.length; c++) 
  //   if (totalKeys[c] != "status_0" || totalKeys[c] != "status_1") 
  //     countTotal++;
  // return countVital / float(countTotal);
}

float GetBadCellRatio() {
  return cellCountBad/(cellSize*cellSize) / float(cellCountVital);
  // int countVital = 0;
  // int countBad = 0;
  // String[] countKeys = cellCounts.keyArray();
  // String[] totalKeys = cellTotals.keyArray();
  // for (int c = 0; c < countKeys.length; c++) {
  //   if (countKeys[c] != "status_0" || countKeys[c] != "status_1") {
  //       countVital++;
  //     } else {
  //       countBad++;
  //     }
  // }
  // return countBad / float(countVital);
}
